{$R-,Q-,S-,Q-}
Program Demo;
Uses crt; { for keypressed only }

{$i pal_fire.src}

Procedure vidMode(mode : byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

var Scr: array[0..199,0..319] of byte absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;
var Scr2: TScr2 absolute $A000:$0000;
var Scr3, Scr4: ^TScr2;

  const Flakes = 9;            { try less flakes for faster snowfall }
  const fading:integer=4;

procedure circle(var buf; x,y:integer);
const s:array[0..7,0..7] of char = (
                  '  ####  ',
                  ' #    # ',
                  '#      #',
                  '#  ##  #',
                  '#  ##  #',
                  '#      #',
                  ' #    # ',
                  '  ####  '
  );
  var ptr: ^byte;
begin
  ptr := @buf;
  inc(ptr, (100-4+y)*320+(160-4+x));
  for y := 0 to 7 do begin
    for x := 0 to 7 do begin
      if s[y,x]<>' ' then ptr^ := 255;
      inc(ptr);
    end;
    inc(ptr,320-8);
  end;
end;

procedure wash(var source, dest); assembler;
label m1, m2;
asm
  push ds
  push es

  mov  dx, fading
  xor  dh,dh
  mov  ds, word ptr [dest+2]
  mov  es, word ptr [source+2]
  xor  si,si
  xor  di,di

m1:
  xor  ah,ah
  mov  al,[es:si]
  shl  ax,2
  add  al,[es:si+1]
  adc  ah,dh
  add  al,[es:si-1]
  adc  ah,dh
  add  al,[es:si+320]
  adc  ah,dh
  add  al,[es:si-320]
  adc  ah,dh
  shr  ax,3
  mov  [ds:di],al
  sub  al, dl
  jl   m2
  mov  [ds:di],al
m2:
  dec  di
  dec  si
  jnz  m1

  pop  es
  pop  ds
end;

{---------------------------MAIN PROGRAM-------------------------}

var
  CurFlake : integer;                        { snowflake counter }
  i : longint;                       { to add velocity to flakes }
  j: word;
  x,y: array[0..Flakes] of integer;         { lookup tables }
  label m1,m2,mexit;

BEGIN
  randomize;
  for curFlake:=0 to Flakes do        { set up snow lookup table }
  begin
  end;

  vidMode($13);                       { 320x200x256 graphics mode }

  SetPalette;

  i := 0; { change to 100 or higher to get rid of start explosion }

  GetMem(Scr3,65535);
  GetMem(Scr4,65535);
  FillChar(Scr4^,65535,#0);
  FillChar(Scr3^,65535,#0);

  repeat
    inc(i);

    wash(scr4^,scr3^);

    for curFlake:=0 to Flakes do
    begin

      x[curflake] := round(80*sin(i/35+3*curflake*2*pi/(flakes+1)));
      y[curflake] := round(80*cos(i/25+curflake*2*pi/(flakes+1)));

        circle(Scr3^,round(x[curflake]),round(y[curflake]));

      end;

    Scr2 := Scr3^;
    Scr4^ := Scr3^;

{    while (port[$3da] and $08) = $08 do;  { wait for vRetrace to }
{    while (port[$3da] and $08) = $00 do;  { start and end        }
    if keypressed then case readkey of
      ' ': for j:=0 to Flakes do begin
             x[j] := 0;
             y[j] := 0;
           end;
      #27: goto mexit;
      '-': inc(fading);
      '+': dec(fading);
      '*': fading :=0;
    end;
  until false;

  mexit:
  vidMode($03);                       { return to 80x25 textmode }
  writeln('i = ',i);
end.

